-----------------------------------------------------------------
-- Alloy4DP -- Alloy for Declarative Processes
-- Copyright (C) 2012, 2013  Yoann Laurent (yoann.laurent@lip6.fr)

-- This program is free software: you can redistribute it and/or
-- modify it under the terms of the GNU General Public License as
-- published by the Free Software Foundation, either version 3 of the
-- License, or (at your option) any later version.

-- This program is distributed in the hope that it will be useful, but
-- WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see
-- <http://www.gnu.org/licenses/>.
-----------------------------------------------------------------

open declarative
// ---- (1) [Process]  
one sig a extends Activity {}
one sig b extends Activity {}
one sig c extends Activity {}
fact constraints {
	atomic[Activity]
	existence[b, 1, integer/max]
	existence[c, 0, integer/max]
	precedence[b, a]
}
// ---- (2) [Goals]
pred goals {
	existence[c,0,0]
	existence[b,1,1]
}
// ---- (3) [Trace]
pred trace {
	setState[State0, none]
	setState[State1, a]
	traces[State1]
}
// ---- [Alloy command] 
run {goals and trace} 
	for 0 but  3 Activity, 15 State




